/*
	File:		TSMTE.h

	Contains:	Definitions for TSMTE

	Written by:	Kida Yasuo, Hara Keisuke

	Copyright:	1991, 1992 Apple Operations and Technologies Japan, Inc.
				All rights reserved.

*/

#ifndef	__TSMTE__
#define	__TSMTE__

#ifndef	__TEXTEDIT__
#include <TextEdit.h>
#endif

#ifndef	__TEXTSERVICES__
#include "TextServices.h"
#endif


typedef pascal void ( *TSMUpdateProcPtr)( TEHandle textH, long fixLen,
										  long inputAreaStart, long inputAreaEnd,
										  long pinStart, long pinEnd, long refCon );

typedef struct {
	TEHandle				textH;			//	TEHandle
	TSMUpdateProcPtr		updateProc;		//	if not nil, TSMTE call this proc
	long					updateFlag;		//	flags described below
	long					refCon;			//	reference constant for application use
} TSMTERec, *TSMTERecPtr, **TSMTERecHandle;

enum {
	kTSMTEAutoScroll	= 1					//	auto scroll on
};

#define kTSMTEInterfaceType			'tmTE'
#define kTSMTESignature				'tmTE'

#endif
